import mysql.connector
from geopy.geocoders import Nominatim
import webbrowser
import time

# Configurar as credenciais de conexão
# 198.136.58.203 antigo
db_config = {
    "host": "187.45.179.18",
    "user": "colibexcom_user",
    "password": "wo3dZ}@*eS$%",
    "database": "colibexcom_banco"
}

def get_address_from_db():
    try:
        # Estabelecer a conexão com o banco de dados
        connection = mysql.connector.connect(**db_config)
        cursor = connection.cursor()

        # Consulta SQL para obter um endereço aleatório
        query = """
        SELECT id, endereco, numero, cidade, estado
        FROM `z_elemento_95_imoveis`
        WHERE estado = 'SP' AND lat = '' AND lon = ''
        LIMIT 1;
        """

        cursor.execute(query)

        # Obter o resultado
        result = cursor.fetchone()
        if result:
            return result
        else:
            return None

    except mysql.connector.Error as error:
        print(f"Erro: {error}")
        return None
    finally:
        # Fechar a conexão
        if connection.is_connected:
            cursor.close()
            connection.close()

def get_lat_lng(address):
    geolocator = Nominatim(user_agent="sistemapro")
    location = None

    def geocode_with_retry(address_str):
        max_retries = 3
        retries = 0
        while retries < max_retries:
            try:
                return geolocator.geocode(address_str)
            except Exception as e:
                print(f"Tentativa {retries + 1} falhou. Erro: {e}")

                # Verifica se a exceção é devido a um tempo de espera esgotado
                if 'Service timed out' in str(e):
                    time.sleep(10)

                retries += 1
        return None

    # Converter todos os elementos de address para strings
    address_str = [str(item) for item in address]

    # Tenta com todos os campos
    location = geocode_with_retry(", ".join(address_str))
    if location:
        return location.latitude, location.longitude

    # Tenta removendo o campo 'endereco'
    location = geocode_with_retry(", ".join(address_str[1:]))
    if location:
        return location.latitude, location.longitude

    # Tenta removendo o campo 'numero'
    location = geocode_with_retry(", ".join(address_str[0:1] + address_str[2:]))
    if location:
        return location.latitude, location.longitude

    # Tenta apenas com cidade e estado
    location = geocode_with_retry(", ".join(address_str[3:]))
    if location:
        return location.latitude, location.longitude

    return None, None

def update_database_with_coordinates(id, lat, lon):
    try:
        connection = mysql.connector.connect(**db_config)
        cursor = connection.cursor()

        # Atualizar o registro com as coordenadas
        update_query = """
        UPDATE `z_elemento_95_imoveis`
        SET lat = %s, lon = %s
        WHERE id = %s;
        """
        cursor.execute(update_query, (lat, lon, id))
        connection.commit()
        print(f"Registro atualizado com as coordenadas - ID: {id}, Latitude: {lat}, Longitude: {lon}")

    except mysql.connector.Error as error:
        print(f"Erro ao atualizar o banco de dados: {error}")
    finally:
        cursor.close()
        connection.close()

def main():
    # Obter um endereço do banco de dados
    address = get_address_from_db()

    if address:
        lat, lng = get_lat_lng(address)
        if lat is not None and lng is not None:
            id, _, _, _, _ = address  # Obtém o ID da consulta
            update_database_with_coordinates(id, lat, lng)
            print(f"Latitude: {lat}")
            print(f"Longitude: {lng}")
            # open_google_maps(lat, lng)  # Abrir o Google Maps com as coordenadas
            print(f"Latitude e Longitude não encontradas para o endereço: {address}")
        else:
            print(f"Latitude e Longitude não encontradas para o endereço: {address}")
    else:
        print("Endereço não encontrado no banco de dados.")

    # Aguardar 20 segundos antes de chamar a função main novamente
    time.sleep(10)
    main()

if __name__ == "__main__":
    main()
